Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BoolValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BoolValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/BoolValueFilter.cs	(revision 5502)
@@ -0,0 +1,57 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class BoolValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.EqualityComparison Comparison { get; set; }
+    public bool Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.EqualityComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.BoolValue == Value));
+          case DataTransfer.EqualityComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.BoolValue != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public BoolValueFilter(string name, DataTransfer.EqualityComparison comparison, bool value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public BoolValueFilter(DataTransfer.NameEqualityComparisonBoolFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/DoubleValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/DoubleValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/DoubleValueFilter.cs	(revision 5502)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class DoubleValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.OrdinalComparison Comparison { get; set; }
+    public double Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.OrdinalComparison.Less:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue < Value));
+          case DataTransfer.OrdinalComparison.LessOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue <= Value));
+          case DataTransfer.OrdinalComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue == Value));
+          case DataTransfer.OrdinalComparison.GreaterOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue >= Value));
+          case DataTransfer.OrdinalComparison.Greater:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue > Value));
+          case DataTransfer.OrdinalComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.DoubleValue != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public DoubleValueFilter(string name, DataTransfer.OrdinalComparison comparison, double value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public DoubleValueFilter(DataTransfer.NameOrdinalComparisonDoubleFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/FloatValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/FloatValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/FloatValueFilter.cs	(revision 5502)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class FloatValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.OrdinalComparison Comparison { get; set; }
+    public float Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.OrdinalComparison.Less:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue < Value));
+          case DataTransfer.OrdinalComparison.LessOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue <= Value));
+          case DataTransfer.OrdinalComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue == Value));
+          case DataTransfer.OrdinalComparison.GreaterOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue >= Value));
+          case DataTransfer.OrdinalComparison.Greater:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue > Value));
+          case DataTransfer.OrdinalComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.FloatValue != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public FloatValueFilter(string name, DataTransfer.OrdinalComparison comparison, float value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public FloatValueFilter(DataTransfer.NameOrdinalComparisonFloatFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/IntValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/IntValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/IntValueFilter.cs	(revision 5502)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class IntValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.OrdinalComparison Comparison { get; set; }
+    public int Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.OrdinalComparison.Less:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue < Value));
+          case DataTransfer.OrdinalComparison.LessOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue <= Value));
+          case DataTransfer.OrdinalComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue == Value));
+          case DataTransfer.OrdinalComparison.GreaterOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue >= Value));
+          case DataTransfer.OrdinalComparison.Greater:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue > Value));
+          case DataTransfer.OrdinalComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.IntValue != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public IntValueFilter(string name, DataTransfer.OrdinalComparison comparison, int value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public IntValueFilter(DataTransfer.NameOrdinalComparisonIntFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/LongValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/LongValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/LongValueFilter.cs	(revision 5502)
@@ -0,0 +1,65 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class LongValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.OrdinalComparison Comparison { get; set; }
+    public long Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.OrdinalComparison.Less:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue < Value));
+          case DataTransfer.OrdinalComparison.LessOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue <= Value));
+          case DataTransfer.OrdinalComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue == Value));
+          case DataTransfer.OrdinalComparison.GreaterOrEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue >= Value));
+          case DataTransfer.OrdinalComparison.Greater:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue > Value));
+          case DataTransfer.OrdinalComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.LongValue != Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public LongValueFilter(string name, DataTransfer.OrdinalComparison comparison, long value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public LongValueFilter(DataTransfer.NameOrdinalComparisonLongFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/OrFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/OrFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/OrFilter.cs	(revision 5502)
@@ -22,4 +22,5 @@
 using System;
 using System.Collections.Generic;
+using System.Linq;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemClassNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemClassNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemClassNameFilter.cs	(revision 5502)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Problem.ProblemClass.Name == Value;
+            return x => x.Problem.ProblemClass.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Problem.ProblemClass.Name != Value;
+            return x => x.Problem.ProblemClass.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Problem.ProblemClass.Name.Contains(Value);
+            return x => x.Problem.ProblemClass.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Problem.ProblemClass.Name.Contains(Value);
+            return x => !x.Problem.ProblemClass.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Problem.ProblemClass.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Problem.ProblemClass.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public ProblemClassNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public ProblemClassNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemDataTypeNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemDataTypeNameFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemDataTypeNameFilter.cs	(revision 5502)
@@ -0,0 +1,62 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Data.Linq.SqlClient;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class ProblemDataTypeNameFilter : IFilter {
+    public DataTransfer.StringComparison Comparison { get; set; }
+    public string Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.StringComparison.Equal:
+            return x => x.Problem.DataType.Name == Value;
+          case DataTransfer.StringComparison.NotEqual:
+            return x => x.Problem.DataType.Name != Value;
+          case DataTransfer.StringComparison.Contains:
+            return x => x.Problem.DataType.Name.Contains(Value);
+          case DataTransfer.StringComparison.NotContains:
+            return x => !x.Problem.DataType.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Problem.DataType.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Problem.DataType.Name, Value);
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public ProblemDataTypeNameFilter(DataTransfer.StringComparison comparison, string value) {
+      Comparison = comparison;
+      Value = value;
+    }
+    public ProblemDataTypeNameFilter(DataTransfer.StringComparisonFilter filter) {
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemNameFilter.cs	(revision 5502)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Problem.Name == Value;
+            return x => x.Problem.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Problem.Name != Value;
+            return x => x.Problem.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Problem.Name.Contains(Value);
+            return x => x.Problem.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Problem.Name.Contains(Value);
+            return x => !x.Problem.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Problem.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Problem.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public ProblemNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public ProblemNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemPlatformNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemPlatformNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/ProblemPlatformNameFilter.cs	(revision 5502)
@@ -21,8 +21,9 @@
 
 using System;
+using System.Data.Linq.SqlClient;
 using System.Linq.Expressions;
 using HeuristicLab.Services.OKB.DataAccess;
 
-namespace HeuristicLab.Services.OKB {
+namespace HeuristicLab.Services.OKB.Query.Filters {
   public class ProblemPlatformNameFilter : IFilter {
     public DataTransfer.StringComparison Comparison { get; set; }
@@ -33,11 +34,15 @@
         switch (Comparison) {
           case DataTransfer.StringComparison.Equal:
-            return x => x.Experiment.Problem.Platform.Name == Value;
+            return x => x.Problem.Platform.Name == Value;
           case DataTransfer.StringComparison.NotEqual:
-            return x => x.Experiment.Problem.Platform.Name != Value;
+            return x => x.Problem.Platform.Name != Value;
           case DataTransfer.StringComparison.Contains:
-            return x => x.Experiment.Problem.Platform.Name.Contains(Value);
+            return x => x.Problem.Platform.Name.Contains(Value);
           case DataTransfer.StringComparison.NotContains:
-            return x => !x.Experiment.Problem.Platform.Name.Contains(Value);
+            return x => !x.Problem.Platform.Name.Contains(Value);
+          case DataTransfer.StringComparison.Like:
+            return x => SqlMethods.Like(x.Problem.Platform.Name, Value);
+          case DataTransfer.StringComparison.NotLike:
+            return x => !SqlMethods.Like(x.Problem.Platform.Name, Value);
           default:
             return x => true;
@@ -50,5 +55,5 @@
       Value = value;
     }
-    public ProblemPlatformNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public ProblemPlatformNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunClientNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunClientNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunClientNameFilter.cs	(revision 5502)
@@ -24,5 +24,5 @@
 using HeuristicLab.Services.OKB.DataAccess;
 
-namespace HeuristicLab.Services.OKB {
+namespace HeuristicLab.Services.OKB.Query.Filters {
   public class RunClientNameFilter : IFilter {
     public DataTransfer.StringComparison Comparison { get; set; }
@@ -40,4 +40,8 @@
           case DataTransfer.StringComparison.NotContains:
             throw new NotSupportedException();
+          case DataTransfer.StringComparison.Like:
+            throw new NotSupportedException();
+          case DataTransfer.StringComparison.NotLike:
+            throw new NotSupportedException();
           default:
             return x => true;
@@ -50,5 +54,5 @@
       Value = value;
     }
-    public RunClientNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public RunClientNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunCreatedDateFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunCreatedDateFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunCreatedDateFilter.cs	(revision 5502)
@@ -24,5 +24,5 @@
 using HeuristicLab.Services.OKB.DataAccess;
 
-namespace HeuristicLab.Services.OKB {
+namespace HeuristicLab.Services.OKB.Query.Filters {
   public class RunCreatedDateFilter : IFilter {
     public DataTransfer.OrdinalComparison Comparison { get; set; }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunRandomSeedFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunRandomSeedFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunRandomSeedFilter.cs	(revision 5502)
@@ -24,5 +24,5 @@
 using HeuristicLab.Services.OKB.DataAccess;
 
-namespace HeuristicLab.Services.OKB {
+namespace HeuristicLab.Services.OKB.Query.Filters {
   public class RunRandomSeedFilter : IFilter {
     public DataTransfer.OrdinalComparison Comparison { get; set; }
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunUserNameFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunUserNameFilter.cs	(revision 5482)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/RunUserNameFilter.cs	(revision 5502)
@@ -24,5 +24,5 @@
 using HeuristicLab.Services.OKB.DataAccess;
 
-namespace HeuristicLab.Services.OKB {
+namespace HeuristicLab.Services.OKB.Query.Filters {
   public class RunUserNameFilter : IFilter {
     public DataTransfer.StringComparison Comparison { get; set; }
@@ -40,4 +40,8 @@
           case DataTransfer.StringComparison.NotContains:
             throw new NotSupportedException();
+          case DataTransfer.StringComparison.Like:
+            throw new NotSupportedException();
+          case DataTransfer.StringComparison.NotLike:
+            throw new NotSupportedException();
           default:
             return x => true;
@@ -50,5 +54,5 @@
       Value = value;
     }
-    public RunUserNameFilter(DataTransfer.SetComparisonStringFilter filter) {
+    public RunUserNameFilter(DataTransfer.StringComparisonFilter filter) {
       Comparison = filter.Comparison;
       Value = filter.Value;
Index: branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/StringValueFilter.cs
===================================================================
--- branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/StringValueFilter.cs	(revision 5502)
+++ branches/OKB (trunk integration)/HeuristicLab.Services.OKB/3.3/Query/Filters/StringValueFilter.cs	(revision 5502)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Data.Linq.SqlClient;
+using System.Linq;
+using System.Linq.Expressions;
+using HeuristicLab.Services.OKB.DataAccess;
+
+namespace HeuristicLab.Services.OKB.Query.Filters {
+  public class StringValueFilter : IFilter {
+    public string Name { get; protected set; }
+    public DataTransfer.StringComparison Comparison { get; set; }
+    public string Value { get; set; }
+
+    public Expression<Func<Run, bool>> Expression {
+      get {
+        switch (Comparison) {
+          case DataTransfer.StringComparison.Equal:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.StringValue == Value));
+          case DataTransfer.StringComparison.NotEqual:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && (y.StringValue != Value));
+          case DataTransfer.StringComparison.Contains:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && y.StringValue.Contains(Value));
+          case DataTransfer.StringComparison.NotContains:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && !y.StringValue.Contains(Value));
+          case DataTransfer.StringComparison.Like:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && SqlMethods.Like(y.StringValue, Value));
+          case DataTransfer.StringComparison.NotLike:
+            return x => x.Values.Any(y => (y.ValueName.Name == Name) && !SqlMethods.Like(y.StringValue, Value));
+          default:
+            return x => true;
+        }
+      }
+    }
+
+    public StringValueFilter(string name, DataTransfer.StringComparison comparison, string value) {
+      Name = name;
+      Comparison = comparison;
+      Value = value;
+    }
+    public StringValueFilter(DataTransfer.NameStringComparisonFilter filter) {
+      Name = filter.Name;
+      Comparison = filter.Comparison;
+      Value = filter.Value;
+    }
+  }
+}
